package dev.micle.totemofreviving.item.crafting;

import dev.micle.totemofreviving.item.totem.TotemItem;
import dev.micle.totemofreviving.setup.ModRecipes;
import net.minecraft.world.inventory.CraftingContainer;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.crafting.RecipeSerializer;
import net.minecraft.world.item.crafting.ShapedRecipe;
import net.minecraft.world.level.Level;

public class TotemRecipe extends ExtendedShapedRecipe {
	public TotemRecipe(ShapedRecipe recipe) {
		super(recipe);
	}
	
	@Override
	public RecipeSerializer<?> getSerializer() {
		return ModRecipes.TOTEM_RECIPE.get();
	}
	
	@Override
	public boolean matches(CraftingContainer inventory, Level world) {
		if (!TotemItem.isEnabled(getResultItem())) {
			return false;
		}
		return getBaseRecipe().matches(inventory, world);
	}
	
	@Override
	public ItemStack assemble(CraftingContainer inventory) {
		return getBaseRecipe().getResultItem().copy();
	}
}
